--[[============================================================================
main.lua
============================================================================]]--

-- Placeholder for the dialog
local dialog = nil

-- Placeholder to expose the ViewBuilder outside the show_dialog() function
local vb = nil

-- Reload the script whenever this file is saved. 
-- Additionally, execute the attached function.
_AUTO_RELOAD_DEBUG = function()
  
end

-- Read from the manifest.xml file.
class "RenoiseScriptingTool" (renoise.Document.DocumentNode)
  function RenoiseScriptingTool:__init()    
    renoise.Document.DocumentNode.__init(self) 
    self:add_property("Name", "Untitled Tool")
    self:add_property("Id", "Unknown Id")
  end

local manifest = RenoiseScriptingTool()
local ok,err = manifest:load_from("manifest.xml")
local tool_name = manifest:property("Name").value
local tool_id = manifest:property("Id").value
local edit_pos = nil

--------------------------------------------------------------------------------
-- Main functions
--------------------------------------------------------------------------------

local function isPlaying()
  edit_pos = renoise.song().transport.edit_pos
end

local function set_sequencer_notifier()
  local song = renoise.song()
  if not song.transport.playing_observable:has_notifier(isPlaying) then
    song.transport.playing_observable:add_notifier(isPlaying)
  end
end

local function ContinueFromLastPosition()
  if edit_pos == nil then
    edit_pos = renoise.song().transport.edit_pos
  end
  
  renoise.song().transport.edit_pos = edit_pos
  renoise.song().transport.playback_pos = edit_pos
  renoise.song().transport.playing = true
end


  if not renoise.tool().app_new_document_observable:has_notifier(set_sequencer_notifier) then
    renoise.tool().app_new_document_observable:add_notifier(set_sequencer_notifier)
  end

--------------------------------------------------------------------------------
-- Key Binding
--------------------------------------------------------------------------------

renoise.tool():add_keybinding {
  name = "Global:Transport:" .. tool_name.."...",
  invoke = ContinueFromLastPosition
}


--------------------------------------------------------------------------------
-- MIDI Mapping
--------------------------------------------------------------------------------

--[[
renoise.tool():add_midi_mapping {
  name = tool_id..":Show Dialog...",
  invoke = show_dialog
}
--]]
